//+------------------------------------------------------------------+
//|                                             Aroon oscillator.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  Silver
#property indicator_color2  LimeGreen
#property indicator_color3  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum 0
#property indicator_maximum 1


extern int    AroonPeriod = 25;
extern int    PriceHigh   = PRICE_CLOSE;
extern int    PriceLow    = PRICE_CLOSE;
extern int    MaPeriod    = 14;
extern int    MaMethod    = MODE_EMA;
extern double Filter      = 50;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffer3); SetIndexStyle(2,DRAW_HISTOGRAM);
      SetLevelValue(0, Filter);
      SetLevelValue(1,-Filter);
   IndicatorShortName("Aroon oscillator ("+AroonPeriod+")");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double prices[][2];
#define _high 0
#define _low  1
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
      if (ArrayRange(prices,0) != Bars) ArrayResize(prices,Bars);
      
   
   //
   //
   //
   //
   //
   
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      prices[r][_high] = iMA(NULL,0,MaPeriod,0,MaMethod,PriceHigh,i);
      prices[r][_low ] = iMA(NULL,0,MaPeriod,0,MaMethod,PriceLow ,i);
         double max = prices[r][_high]; double maxi = 0;
         double min = prices[r][_low ]; double mini = 0;
         for (int k=1; k<=AroonPeriod && (r-k)>=0; k++)
         {
             if (max<prices[r-k][_high]) { maxi=k; max = prices[r-k][_high]; }
             if (min>prices[r-k][_low ]) { mini=k; min = prices[r-k][_low ]; }
         }                  
         double osc = 100.0*(mini-maxi)/AroonPeriod;
         buffer1[i] = EMPTY_VALUE;
         buffer2[i] = EMPTY_VALUE;
         buffer3[i] = EMPTY_VALUE;
            if (osc> Filter) { buffer2[i] = 1; continue; }
            if (osc<-Filter) { buffer3[i] = 1; continue; }
                                      buffer1[i] = 1;
   }
   return(0);
}